diff --git a/target/linux/at91/sam9x/config-default b/target/linux/at91/sam9x/config-default
index 95c229880bb9..bd9d106f5b24 100644
--- a/target/linux/at91/sam9x/config-default
+++ b/target/linux/at91/sam9x/config-default
@@ -296,7 +296,6 @@ CONFIG_USB_COMMON=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_EHCI_HCD_AT91=y
 # CONFIG_USB_EHCI_HCD_PLATFORM is not set
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_OHCI_HCD=y
 CONFIG_USB_OHCI_HCD_AT91=y
diff --git a/target/linux/at91/sama5/config-default b/target/linux/at91/sama5/config-default
index 20fb90502a60..852e5c95b7a6 100644
--- a/target/linux/at91/sama5/config-default
+++ b/target/linux/at91/sama5/config-default
@@ -456,7 +456,6 @@ CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_EHCI_HCD_AT91=y
 # CONFIG_USB_EHCI_HCD_PLATFORM is not set
 # CONFIG_USB_EHCI_ROOT_HUB_TT is not set
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_HID=y
 CONFIG_USB_OHCI_HCD=y
diff --git a/target/linux/bcm27xx/bcm2709/config-5.10 b/target/linux/bcm27xx/bcm2709/config-5.10
index 928f17c974cc..7a645e6025af 100644
--- a/target/linux/bcm27xx/bcm2709/config-5.10
+++ b/target/linux/bcm27xx/bcm2709/config-5.10
@@ -435,7 +435,6 @@ CONFIG_USB=y
 CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
 CONFIG_USB_COMMON=y
 CONFIG_USB_DWCOTG=y
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_LAN78XX=y
 CONFIG_USB_NET_DRIVERS=y
diff --git a/target/linux/bcm27xx/bcm2711/config-5.10 b/target/linux/bcm27xx/bcm2711/config-5.10
index 861dd1e58d5a..bdbf093dd5f3 100644
--- a/target/linux/bcm27xx/bcm2711/config-5.10
+++ b/target/linux/bcm27xx/bcm2711/config-5.10
@@ -437,7 +437,6 @@ CONFIG_USB=y
 CONFIG_USB_ANNOUNCE_NEW_DEVICES=y
 CONFIG_USB_COMMON=y
 CONFIG_USB_DWCOTG=y
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_PCI=y
 CONFIG_USB_PHY=y
diff --git a/target/linux/generic/config-5.10 b/target/linux/generic/config-5.10
index 69d9ddd0f4de..7b952e8ca895 100644
--- a/target/linux/generic/config-5.10
+++ b/target/linux/generic/config-5.10
@@ -4578,6 +4578,7 @@ CONFIG_PROC_SYSCTL=y
 # CONFIG_PWM is not set
 # CONFIG_PWM_DEBUG is not set
 # CONFIG_PWM_FSL_FTM is not set
+# CONFIG_PWM_JZ4740 is not set
 # CONFIG_PWM_PCA9685 is not set
 CONFIG_PWRSEQ_EMMC=y
 # CONFIG_PWRSEQ_SD8787 is not set
@@ -6442,6 +6443,7 @@ CONFIG_USB_EHCI_TT_NEWSCHED=y
 # CONFIG_USB_EMI26 is not set
 # CONFIG_USB_EMI62 is not set
 # CONFIG_USB_EPSON2888 is not set
+# CONFIG_USB_ETH is not set
 # CONFIG_USB_EZUSB_FX2 is not set
 # CONFIG_USB_FEW_INIT_RETRIES is not set
 # CONFIG_USB_FOTG210_HCD is not set
diff --git a/target/linux/imx6/config-5.10 b/target/linux/imx6/config-5.10
index 9238678258f5..126652cf980e 100644
--- a/target/linux/imx6/config-5.10
+++ b/target/linux/imx6/config-5.10
@@ -470,7 +470,6 @@ CONFIG_USB_COMMON=y
 CONFIG_USB_EHCI_HCD=y
 # CONFIG_USB_EHCI_HCD_PLATFORM is not set
 # CONFIG_USB_EHCI_MXC is not set
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_MXS_PHY=y
 CONFIG_USB_OTG=y
diff --git a/target/linux/mediatek/mt7623/config-5.10 b/target/linux/mediatek/mt7623/config-5.10
index d21fe2cdb2bd..917e34608b9a 100644
--- a/target/linux/mediatek/mt7623/config-5.10
+++ b/target/linux/mediatek/mt7623/config-5.10
@@ -587,7 +587,6 @@ CONFIG_UNINLINE_SPIN_UNLOCK=y
 CONFIG_UNWINDER_ARM=y
 CONFIG_USB=y
 CONFIG_USB_COMMON=y
-# CONFIG_USB_ETH is not set
 CONFIG_USB_F_ACM=y
 CONFIG_USB_F_ECM=y
 CONFIG_USB_F_MASS_STORAGE=y
diff --git a/target/linux/mxs/config-5.10 b/target/linux/mxs/config-5.10
index 2fdb51238cdb..8bc075a916cd 100644
--- a/target/linux/mxs/config-5.10
+++ b/target/linux/mxs/config-5.10
@@ -231,7 +231,6 @@ CONFIG_USB_CHIPIDEA_UDC=y
 CONFIG_USB_COMMON=y
 CONFIG_USB_EHCI_HCD=y
 # CONFIG_USB_EHCI_HCD_PLATFORM is not set
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_MXS_PHY=y
 CONFIG_USB_OTG=y
diff --git a/target/linux/sunxi/config-5.10 b/target/linux/sunxi/config-5.10
index 3f6f849e81e2..59d873154335 100644
--- a/target/linux/sunxi/config-5.10
+++ b/target/linux/sunxi/config-5.10
@@ -484,7 +484,6 @@ CONFIG_USB_DWC2=y
 CONFIG_USB_DWC2_HOST=y
 CONFIG_USB_EHCI_HCD=y
 CONFIG_USB_EHCI_HCD_PLATFORM=y
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_NET_DRIVERS=y
 CONFIG_USB_OHCI_HCD=y
diff --git a/target/linux/zynq/config-5.10 b/target/linux/zynq/config-5.10
index d18bb39d8d34..d30b4f8467a2 100644
--- a/target/linux/zynq/config-5.10
+++ b/target/linux/zynq/config-5.10
@@ -507,7 +507,6 @@ CONFIG_USB_COMMON=y
 CONFIG_USB_EHCI_HCD=y
 # CONFIG_USB_EHCI_HCD_PLATFORM is not set
 # CONFIG_USB_EHCI_TT_NEWSCHED is not set
-# CONFIG_USB_ETH is not set
 CONFIG_USB_GADGET=y
 CONFIG_USB_GADGET_XILINX=y
 CONFIG_USB_HID=y